<template>
  <div>
    <div class="development-environment">
      <q-page padding>
        <p>
          The Nephele Synergetic Meta-Orchestration (SMO) framework is devoted
          to the deployment of Hyper-Distributed Applications (HDAs) in the
          compute continuum.
        </p>

        <h6>Development Environment</h6>

        <div class="section">
          <h6>Short Description</h6>
          <p>
            This section provides an overview of the development environment,
            serving as an index to the documentation required during the
            development of a HDA:
          </p>
          <ul>
            <li>Development Sandbox</li>
            <li>HDA Technologies and Artifacts</li>
            <li>HDA Registry</li>
          </ul>

          <q-img :src="t41" class="imagelarge" />
        </div>

        <div class="section">
          <h6>Development Sandbox</h6>
          Participants in the Nephele project that want to develop an HDA are
          provided with two complementaries utilities to facilitate their
          onboarding and reduce the learning curve.
          <ul>
            <li>Gitlab Development Sandbox</li>
            : Is meant for a technical participant who is familiar with all
            technologies involved and needs support to create services (as
            artifacts). It covers all the artifacts, including the HDA Graph.
            <li>Dashboard Development Sandbox</li>
            : Is meant for a non-technical participant who wants to connect
            already-existing services (as artifacts) in a HDA Graph and deploy
            it through the SMO.
          </ul>
          <h5>Gitlab Development Sandbox</h5>
          As part of the Open Source repository for the Nephele project, it has
          been added about template repository which can be replicated to take
          advantage of a predefined CICD pipeline & a configurable connexion to
          the HDAR which in turn, allows to directly use the artifacts in the
          Nephele Dashboard.

          <h5>Dashboard Development Sandbox</h5>
          This tab in the Nephele Dashboard enables a way to easily create a HDA
          Graph from a UI. The process is split in two steps:
          <ul>
            <li>Create Baseline HDAG</li>
            : Based on a user intent, a template is generated with the required
            information to serve as a baseline descriptor which is customized as
            part of the second step.
            <li>Customize HDAG</li>
            : Customize the HDAG to configure the services for this particular
            deploymnet.
          </ul>
        </div>

        <div class="section">
          <h6>HDA Technologies & Artifacts</h6>
          An HDA is the term used to describe a highly-distributed application
          composed of multiple types of services which are treated as a shared
          deployment unit instead of being deployed and managed individually.
          The HDAG is the top-most artifact used by the SMO in order to deploy
          an HDA. It provides information about deployment which combines custom
          intent-orchestration mechanism with the configuration of the services
          for the specific deployment. All workloads wihtin the HDAG are based
          in the cloud-native paradigm. The following figures depict an HDAG,
          first using a visual high level representation and later giving
          examples applied to the use VOs and cVOs
        </div>
        <q-img :src="highlevel_hdag" class="image" />
        <q-img :src="highlevel_hdag_with_vos" class="image" />

        <div class="section">
          <h6>HDA Registry</h6>

          HDAR leverages an Open Container Initiative
          ([OCI](https://opencontainers.org/)) compatible image Registry as
          Storage ([ORAS](https://oras.land/)) to finally align the storage,
          distribution and exposure mechanisms for artifacts of the Vertical
          Service Providers (VSP) and the Communication Service Providers (CSP).
          <ul>
            <li>Artifact</li>
            : Distributable outcome of a software development in the form of a
            filesystem bundle, essentially, anything that a system or user might
            need to successfully run a software.
            <li>Registry</li>
            : A registry is a storage and distribution system for those
            artifacts.
            <li>Repository</li>
            : A registry is organized into repositories, where a repository
            holds all the versions of a specific artifact.
          </ul>

          The HDAR provides support for the following artifacts:
          <ul>
            <li>Docker</li>
            <li>Helm</li>
            <li>OSM NS & VNF</li>
            <li>VO</li>
            <li>cVO</li>
            <li>HDAG</li>
          </ul>

          The HDAR is built as the combination of multiple components which in
          provide the following features:
        </div>
        <q-img :src="hdar_modules" class="imagemedium" />
        <div>
          <div class="section">
            <h5>Usage of HDAR</h5>
            <p>
              From the developer's perspective, the HDAR is interacted in the
              same way as they would do with docker. The CLI is distributed as a
              single binary with no dependencies on the system requirements. CLI
              commands :
              <br /><br />

              ./hdarctl --help<br />
              Hyper Distributed Application Registry Control toolkit<br />
              <br />
              Usage:<br />
              hdarctl [command]<br />
              <br />
              Available Commands:<br />
              -create: Create an artifact [TYPE=(VNF,NS,HDAG,WOT)]<br />
              -help: Help about any command<br />
              -lint: lint an artifact<br />
              -login: Logs in to the HDAR<br />
              -logout: Logs out from the HDAR<br />
              -manifest: Pulls an OCI manifest. <br />
              -package: Parent command to tar and untar commands<br />
              -pull: Pulls an OCI artifact from a the HDAR<br />
              -push: Pushes a local artifact to the HDAR<br />
              <br />
              Flags:<br />
              -h, --help help for hdarctl<br />
              <br />
              Use "hdarctl [command] --help" for more information about a
              command.<br />
              REST API available as a . Online here
              nephele-platform.netmode.ece.ntua.gr/hdarapi/swagger/index.html<br />
            </p>

            Example of usage
            <p>
              ./hdarctl login nephele-platform.netmode.ece.ntua.gr -u YOUR_USER
              -p YOUR_PASSWORD<br />
              ./hdarctl lint wot-plenary/vo1<br />
              ./hdarctl package tar wot-plenary/vo1 -d .<br />
              ./hdarctl push vo1-0.1.0.tar.gz
              nephele-platform.netmode.ece.ntua.gr<br />
              ./hdarctl lint wot-plenary/hda_graph_wot_1 <br />
              ./hdarctl package tar wot-plenary/hda_graph_wot_1 -d .<br />
              ./hdarctl push hda_graph_wot_1-0.1.0.tar.gz
              nephele-platform.netmode.ece.ntua.gr<br />
            </p>
          </div>
        </div>
      </q-page>
    </div>
  </div>
</template>

<script setup lang="ts">
import t41 from 'assets/t4-1.png';
import hdar_modules from 'assets/hdar-modules.png';
import highlevel_hdag from 'assets/highlevel-hdag.png';
import highlevel_hdag_with_vos from 'assets/highlevel-hdag-with-vos.png';
</script>

<style scoped>
.image {
  width: 500px;
  height: 300px;
}
.imagelarge {
  width: 900px;
  height: 500px;
}
.imagemedium {
  width: 800px;
  height: 300px;
}
</style>
